# SoundClouder

![SoundClouder Banner](https://github.com/1omka/soundclouder/blob/main/images/banner.png)

[***SoundClouder***](https://github.com/1omka/soundclouder) is a library for downloading publicly available non-Go SoundCloud songs, playlists, albums or compilations. It also applies bundled **metadata** with tags, including album cover. Available formats are **MP3** and **OPUS**(sometimes not) with constant quality of **128kbps**. There is also support for both **HLS** & **Progressive** streams. 

## **Disclaimer**
Availability of metadata from SoundCloud API responses is directly depends on whether the author/uploader provides it, so it can be inaccurate. 

**For example**: there may be no album title, even if the song is in the album, and in such a situation SoundClouder will set the song title as an album title.

## **Installation**

SoundClouder depends on [mutagen](https://github.com/quodlibet/mutagen) (for metadata embedding) and [requests](https://github.com/psf/requests) libraries. 

The prerequisite is also [Python](https://python.org/downloads) version 3.6 or greater (tested in Python 3.10).

How to install from PyPI with pip:
> Linux:
```bash
$ python -m pip install soundclouder
```
> Windows: 
```cmd|pwsh
C:\ py.exe -m pip install soundclouder
```

## **Usage**
> Command-line interface:
```bash|cmd|pwsh
soundclouder [--help] -u "https://soundcloud.com/rick-astley-official/never-gonna-give-you-up-4"
```
> In Python:
```python
>>> from soundclouder import SoundClouder
>>> from soundclouder import Streams
>>> SoundClouder(url="...", stream_type=Streams.MP3_HLS)
>>> # With path: (Default - Current Folder)
>>> SoundClouder(url="...", base_path="E:\Music")
>>> ....
```